chroot-browser.sh 7.52 KB
Newer Older
1 2
#!/bin/sh

3 4 5 6 7
if [ "$(whoami)" != "root" ]; then
    echo "This library is useless for non-root users. Exiting..." >&2
    exit 1
fi

8 9
# Import the TBB_INSTALL, TBB_PROFILE and TBB_EXT variables, and
# configure_xulrunner_app_locale().
10 11
. /usr/local/lib/tails-shell-library/tor-browser.sh

12 13 14
# Import windows_camouflage_is_enabled()
. /usr/local/lib/tails-shell-library/tails-greeter.sh

Tails developers's avatar
Tails developers committed
15 16 17
# Import try_for().
. /usr/local/lib/tails-shell-library/common.sh

18 19 20 21 22
# Break down the chroot and kill all of its processes
try_cleanup_browser_chroot () {
    local chroot="${1}"
    local cow="${2}"
    local user="${3}"
23
    try_for 10 "pkill -u ${user} 1>/dev/null 2>&1" 0.1 || \
24
        pkill -9 -u "${user}" 1>/dev/null 2>&1 || :
25
    for mnt in "${chroot}"/dev "${chroot}"/proc "${chroot}" "${cow}"; do
26
        try_for 10 "umount ${mnt} 2>/dev/null" 0.1
27
    done
28
    rmdir "${cow}" "${chroot}" 2>/dev/null
29
}
30 31 32 33 34

# Setup a chroot on a clean aufs "fork" of the root filesystem.
setup_browser_chroot () {
    local chroot="${1}"
    local cow="${2}"
35 36
    local user="${3}"

37 38 39
    # FIXME: When LXC matures to the point where it becomes a viable option
    # for creating isolated jails, the chroot can be used as its rootfs.

40 41
    local cleanup_cmd="try_cleanup_browser_chroot \"${chroot}\" \"${cow}\" \"${user}\""
    trap "${cleanup_cmd}" INT EXIT
42 43

    local rootfs_dir
44 45
    local rootfs_dirs_path="/lib/live/mount/rootfs"
    local tails_module_path="/lib/live/mount/medium/live/Tails.module"
46 47 48 49 50 51 52 53 54 55 56 57 58
    local aufs_dirs=

    # We have to pay attention to the order we stack the filesystems;
    # newest must be first, and remember that the .module file lists
    # oldest first, newest last.
    while read rootfs_dir; do
        rootfs_dir="${rootfs_dirs_path}/${rootfs_dir}"
        mountpoint -q "${rootfs_dir}" && \
        aufs_dirs="${rootfs_dir}=rr+wh:${aufs_dirs}"
    done < "${tails_module_path}"
    # But our copy-on-write dir must be at the very top.
    aufs_dirs="${cow}=rw:${aufs_dirs}"

59 60 61 62 63
    mkdir -p "${cow}" "${chroot}" && \
    mount -t tmpfs tmpfs "${cow}" && \
    mount -t aufs -o "noatime,noxino,dirs=${aufs_dirs}" aufs "${chroot}" && \
    mount -t proc proc "${chroot}"/proc && \
    mount --bind /dev "${chroot}"/dev || \
64
        return 1
65 66

    # Workaround for #6110
67
    chmod -t "${cow}"
68
}
69

70 71
set_chroot_browser_locale () {
    local chroot="${1}"
72 73 74 75
    local browser_name="${2}"
    local browser_user="${3}"
    local locale="${4}"
    local browser_profile="${chroot}/home/${browser_user}/.${browser_name}/profile.default"
76 77 78
    configure_xulrunner_app_locale "${browser_profile}" "${locale}"
}

79 80 81 82
set_chroot_browser_name () {
    local chroot="${1}"
    local name="${2}"
    local locale="${3}"
83
    local ext_dir="${chroot}/${TBB_EXT}"
84
    local pack top rest
85
    if [ "${locale}" != "en-US" ]; then
86
        pack="${ext_dir}/langpack-${locale}@firefox.mozilla.org.xpi"
87 88
        top="browser/chrome"
        rest="${locale}/locale"
89 90
    else
        pack="${chroot}/${TBB_INSTALL}/browser/omni.ja"
91 92
        top="chrome"
        rest="en-US/locale"
93
    fi
94
    local tmp="$(mktemp -d)"
95 96 97 98 99 100 101 102 103
    local branding="${top}/${rest}/branding/brand.dtd"
    # Non-zero exit code due to non-standard ZIP archive.
    # The following steps will fail soon if the extraction failed anyway.
    7z x -o"${tmp}" "${pack}" "${branding}" || true
    sed -i "s/<"'!'"ENTITY\s\+brand\(Full\|Short\)Name.*$/<"'!'"ENTITY brand\1Name \"${name}\">/" "${tmp}/${branding}"
    (cd ${tmp} ; 7z u -tzip "${pack}" .)
    chmod a+r "${pack}"
    rm -Rf "${tmp}"
}
104 105 106 107

# Start the browser in the chroot
run_chroot_browser () {
    local chroot="${1}"
108 109 110
    local browser_name="${2}"
    local chroot_user="${3}"
    local local_user="${4}"
111 112 113 114 115

    sudo -u ${local_user} xhost +SI:localuser:${chroot_user} 2>/dev/null
    chroot ${chroot} sudo -u ${chroot_user} /bin/sh -c \
        '. /usr/local/lib/tails-shell-library/tor-browser.sh && \
         exec_firefox -DISPLAY=:0.0 \
116
                      -profile '"/home/${chroot_user}/.${browser_name}/profile.default"
117 118
    sudo -u ${local_user} xhost -SI:localuser:${chroot_user} 2>/dev/null
}
119 120 121 122 123 124

# TorButton forces the Browser name to Tor Browser unless we alter its
# branding files a bit.
set_chroot_torbutton_browser_name () {
    local chroot="${1}"
    local name="${2}"
125 126 127 128 129 130 131
    local locale="${3}"
    local torbutton_locale_dir="${chroot}"/usr/share/xul-ext/torbutton/chrome/locale/${locale}
    if [ ! -d "${torbutton_locale_dir}" ]; then
        # Surprisingly, the default locale is en, not en-US
        torbutton_locale_dir="${chroot}"/usr/share/xul-ext/torbutton/chrome/locale/en
    fi
    sed -i "s/<"'!'"ENTITY\s\+brand\(Full\|Short\)Name.*$/<"'!'"ENTITY brand\1Name \"${name}\">/" "${torbutton_locale_dir}/brand.dtd"
132
}
133 134 135 136 137 138 139 140

# Set the chroot's DNS servers (IPv4 only)
configure_chroot_dns_servers () {
    local chroot="${1}" ; shift
    local ip4_nameservers="${@}"

    rm -f ${chroot}/etc/resolv.conf
    for ns in ${ip4_nameservers}; do
141
        echo "nameserver ${ns}" >> "${chroot}/etc/resolv.conf"
142 143 144 145 146 147
    done
    chmod a+r ${chroot}/etc/resolv.conf
}

set_chroot_browser_permissions () {
    local chroot="${1}"
148 149 150
    local browser_name="${2}"
    local browser_user="${3}"
    local browser_conf="${chroot}/home/${browser_user}/.${browser_name}"
151
    chown -R "${browser_user}:${browser_user}" "${browser_conf}"
152 153 154 155 156 157 158
}

configure_chroot_browser () {
    local chroot="${1}" ; shift
    local browser_name="${1}" ; shift
    local browser_user="${1}" ; shift
    local startpage="${1}" ; shift
159 160
    # Now $@ is a list of paths (that must be valid after chrooting)
    # to extensions to enable.
161 162

    # Prevent sudo from complaining about failing to resolve the 'amnesia' host
163
    echo "127.0.0.1 localhost amnesia" > "${chroot}/etc/hosts"
164 165

    # Create a fresh browser profile for the clearnet user
166
    local browser_conf="${chroot}/home/${browser_user}/.${browser_name}"
167
    local browser_profile="${browser_conf}/profile.default"
168
    local browser_ext="${browser_profile}/extensions"
169 170 171
    mkdir -p "${browser_profile}" "${browser_ext}"

    # Select extensions to enable
172 173 174 175 176
    local extension
    while [ -n "${*}" ]; do
        extension="${1}" ; shift
        ln -s "${extension}" "${browser_ext}"
    done
177 178

    # Set preferences
179
    local browser_prefs="${browser_profile}/preferences/prefs.js"
180
    mkdir -p "$(dirname "${browser_prefs}")"
181
    cp /usr/share/tails/"${browser_name}/prefs.js" "${browser_prefs}"
182 183

    # Set start page to something that explains what's going on
184 185 186 187
    if [ -n "${startpage}" ]; then
        echo 'user_pref("browser.startup.homepage", "'"${startpage}"'");' >> \
            "${browser_prefs}"
    fi
188 189 190 191

    # Customize the GUI
    local browser_chrome="${browser_profile}/chrome/userChrome.css"
    mkdir -p "$(dirname "${browser_chrome}")"
192
    cp /usr/share/tails/"${browser_name}"/userChrome.css "${browser_chrome}"
193 194

    # Remove all bookmarks
195 196 197
    rm -f "${chroot}/${TBB_PROFILE}/bookmarks.html"
    rm -f "${browser_profile}/bookmarks.html"
    rm -f "${browser_profile}/places.sqlite"
198 199 200 201 202 203 204 205

    # Set an appropriate theme, except if we're using Windows
    # camouflage.
    if ! windows_camouflage_is_enabled; then
        cat /usr/share/tails/"${browser_name}"/theme.js >> "${browser_prefs}"
    else
        # The tails-activate-win8-theme script requires that the
        # browser profile is writable by the user running the script.
206
        set_chroot_browser_permissions "${chroot}" "${browser_user}"
207 208
        # The camouflage activation script requires a dbus server for
        # properly configuring GNOME, so we start one in the chroot
209
        chroot "${chroot}" sudo -H -u "${browser_user}" sh -c 'eval `dbus-launch --auto-syntax`; tails-activate-win8-theme' || :
210 211
    fi
}